package org.apache.commons.lang3.tuple;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Map;
import org.apache.commons.lang3.tuple.Pair;

public final class ImmutablePair<L, R> extends Pair<L, R> {
  public static final org.apache.commons.lang3.tuple.ImmutablePair<?, ?>[] EMPTY_ARRAY = (org.apache.commons.lang3.tuple.ImmutablePair<?, ?>[])new org.apache.commons.lang3.tuple.ImmutablePair[0];
  
  private static final org.apache.commons.lang3.tuple.ImmutablePair NULL = of(null, null);
  
  private static final long serialVersionUID = 4954918890077093841L;
  
  public final L left;
  
  public final R right;
  
  public static <L, R> org.apache.commons.lang3.tuple.ImmutablePair<L, R>[] emptyArray() {
    return (org.apache.commons.lang3.tuple.ImmutablePair<L, R>[])EMPTY_ARRAY;
  }
  
  public static <L, R> Pair<L, R> left(L left) {
    return of(left, null);
  }
  
  public static <L, R> org.apache.commons.lang3.tuple.ImmutablePair<L, R> nullPair() {
    return NULL;
  }
  
  public static <L, R> org.apache.commons.lang3.tuple.ImmutablePair<L, R> of(L left, R right) {
    return new org.apache.commons.lang3.tuple.ImmutablePair<>(left, right);
  }
  
  public static <L, R> org.apache.commons.lang3.tuple.ImmutablePair<L, R> of(Map.Entry<L, R> pair) {
    L left;
    R right;
    if (pair != null) {
      left = pair.getKey();
      right = pair.getValue();
    } else {
      left = null;
      right = null;
    } 
    return new org.apache.commons.lang3.tuple.ImmutablePair<>(left, right);
  }
  
  public static <L, R> Pair<L, R> right(R right) {
    return of(null, right);
  }
  
  public ImmutablePair(L left, R right) {
    this.left = left;
    this.right = right;
  }
  
  public L getLeft() {
    return this.left;
  }
  
  public R getRight() {
    return this.right;
  }
  
  public R setValue(R value) {
    throw new UnsupportedOperationException();
  }
}
